use crate::config::{Args, DaemonConfig};
use crate::discord::run_bot;
use j_db::database::Database;
use structopt::StructOpt;

mod config;
mod discord;
mod error;
mod models;

#[tokio::main]
async fn main() {
    env_logger::init();
    let args = Args::from_args();
    let config = DaemonConfig::new(args.config_path);
    let db = Database::new(&config.db_path).unwrap();

    run_bot(db, config).await;
}
